MODULE Lola2;
(* =========================================================================
   Main Program for Lola 2 Compiler on Windows

   Author : Chris Burrows
   Created: Dec 2021
   (c) 2021-2022 CFB Software
   https://www.astrobe.com

   ========================================================================= *)

IMPORT
  IO := "[mscorlib]System.IO",
  Sys := "[mscorlib]System",
  LSC,
  LSV,
  ProgArgs,
  Texts,
  CPmain;

VAR
  w: Texts.Writer;
  r: Texts.Reader;
  fileName, folderName, pathName: Sys.String;

  PROCEDURE WriteLine(s: Sys.String);
  BEGIN
    Texts.WriteString(w, s); Texts.WriteLn(w)
  END WriteLine;

  PROCEDURE GetParameter(VAR pathName: Sys.String);
  VAR
    param: ARRAY 256 OF CHAR;
  BEGIN
    pathName := "";
    IF ProgArgs.ArgNumber() # 1 THEN
      WriteLine("Usage: Lola2 <pathname>");
    ELSE
      ProgArgs.GetArg(0, param);
      pathName := MKSTR(param);
      IF ~IO.File.Exists(pathName) THEN
        WriteLine("Source file: " + pathName + " not found.");
        pathName := "";
      END
    END
  END GetParameter;

  PROCEDURE Run*;
  BEGIN
    WriteLine("Lola v2.0");
    GetParameter(pathName);
    IF pathName # "" THEN
      fileName := IO.Path.GetFileName(pathName);
      folderName := IO.Path.GetDirectoryName(pathName);
      IF folderName # "" THEN IO.Directory.SetCurrentDirectory(folderName) END;
      IF Texts.Open(r, fileName) THEN
        LSC.Compile(r);
        LSV.List()
      ELSE
        WriteLine("Cannot open file: " + fileName)
      END
    END
  END Run;

BEGIN
  Run
END Lola2.
